
#include <LiquidCrystal.h>
#include <Wire.h>
#define TAG 17 // A3
#define numusers 4 //number of users in database
//char* mifare[] = { "1K", "Pro", "UltraLight", "4K", "ProX", "DesFire" };
//int greenpin = 8; //defines digital out pin for green LCD backlight
//int bluepin = 9; //defines digital out pin for blue LCD backlight
int i=0;
String fulltag="";

LiquidCrystal lcd(6, 5, 3, 2, 9, 8); //sets up LCD driver on given pins
#include <Ethernet.h>
#include <SPI.h>
#include <SD.h>
String tagtocheck="";
byte mac[]  = { 0x90, 0xA2, 0xDA, 0x00, 0x94, 0x9F};
byte ip[]   = {  10, 10, 10, 2 }; 
byte serv[] = {  10, 10, 10, 1 }; //sae.mit.edu

int nCount = 0;
boolean foundFlag = 0;
File dumpID;
File backupID;
byte sigma[8] = { //defines character for sigma
  B11111,
  B10000,
  B01000,
  B00100,
  B01000,
  B10000,
  B11111,
  B00000
};

// texting system vars
EthernetServer server(80);
//int relayPin = 8;
int backupPin = 7;
char recd[50];
//int i=0;
int iSpace=0;
char c='0';
String name = "";

// SD variables
const int cs = 4;
//File logFile;
File cardID;
//File phoneNumbers;
String newLine = "";
String newtag=""; //to be used in addRFID
unsigned long curtime=0; //to be used in timeout for rfid user adding

// rfid vars
String tmpStr = "";
boolean authFlag = 0;

void setup() {   
  lcd.createChar(6, sigma);  
  lcd.begin(16, 2);
  //pinMode(greenpin, OUTPUT);     
  //pinMode(bluepin, OUTPUT);
  Serial.begin(19200);
  Wire.begin();
  ledOn(true);
  delay(500);
  ledOn(false);
  Serial.println("Show me your tag");
  welcomescreen();

}
void loop() {
  
  //Serial.println("Got here1");
  while(digitalRead(TAG)){};
  //Serial.println("Got here2");
  readID();
  //Serial.println("Got here3"); 
  while(!digitalRead(TAG)){};
  //Serial.println("Got here4");
}

//void setcolor(String color) { //sets given color to LCD.
// if (color=="green") { 
//   digitalWrite(greenpin, HIGH);
//   digitalWrite(bluepin, LOW);
// }
// if (color=="blue") {
//   digitalWrite(bluepin, HIGH);
//   digitalWrite(greenpin, LOW);
// }
// if (color=="off") {
//   digitalWrite(bluepin, LOW);
//   digitalWrite(greenpin, LOW);
// }
//}

void ledOn(boolean on)
{
  // Send LED command to RFID reader
  Wire.beginTransmission(0x50);
  Wire.write(2);
  Wire.write(0x40);
  Wire.write(on);
  Wire.endTransmission();
}

void welcomescreen() { //Sets LCD to default screen
  lcd.clear();
  //setcolor("blue");
  lcdshow("Welcome to ","");
  lcd.setCursor(11,0);
  lcd.write(6);
  lcd.print("AE");
  lcd.setCursor(0,1);
  lcd.print("Tap/Txt to Enter");
}

void lcdshow(String firstline, String secondline) { //takes two strings and prints to lcd display
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print(firstline);
  lcd.setCursor(0,1);
  lcd.print(secondline);
}

void readID()
{
  // Send SELECT command
  Wire.beginTransmission(0x50);
  Wire.write(1);
  Wire.write(1);
  Wire.endTransmission();
  //Serial.println("Got here readid 1");
  // Wait for response
  while(!digitalRead(TAG))
  {
    // Allow some time to respond
    delay(5);
    //Serial.println("Got here readid 2");
    // Anticipate maximum packet size
    Wire.requestFrom(0x50, 11);
    if(Wire.available())
    {
      Serial.println("wire available");
      Serial.println(Wire.available());
      // Get length of packet
      byte len = Wire.read();
      //Serial.println("Got here readid 3");
      // Wait until whole packet is received
      while(Wire.available() < len)
      {
        // Quit if no response before tag left
        if(digitalRead(TAG)) break;
      }

      // Read command code, should be same as request (1)
      byte command = Wire.read();
      if(command != 1) break;
      //Serial.println("Got here readid 4");
      // Read status
      byte status = Wire.read();
      switch(status)
      {
        case 0: // Success, read ID and tag type
        {
          len -= 2;
          // Get tag ID
          //Serial.println("Got here Fuck you.");
          fulltag=""; //Variable for full, combined RFID tag
          //Serial.println("Got here Fuck you2.");
          while(--len)
          {
            //Serial.println("Got here Fuck you3.");
            byte data = Wire.read();
            if(data < 0x10) Serial.print(0);
            fulltag.concat(data);
            //Serial.println(fulltag);
          }
          //Serial.println("Got here5");
          Serial.println(fulltag);
          //userauth(fulltag);
          //Serial.println("Got here6");
        }
        break;
      case 0x0A: // Multiple Tag collision
        Serial.println("Multiple Tags detected");
        lcdshow("Multiple Tags", "Detected");
        delay(5000);
        break;

      case 1: // No tag
        Serial.println("No tag found");
        lcdshow("No tag Found", "");
        delay(5000);
        break;

      default: // Unexpected
        Serial.println("Unexpected result");
        lcdshow("Unexpected", "Result");
      }
      break;
    }
  }
}

//void userauth(String tag) { //authenticates users and responds accordingly
//   //Iterates over array of users to check if tag is allowed
//   i=0;
//   //Serial.println(users);
//   while (i < numusers) {
//     //Serial.println(i);
//     //Serial.println(users[i][1]);
//     //Serial.println(String(users[i][0]));
//     //String a=String(users[i][0]);
//     if (String(users[i][0]).equals(tag)) {
//       Serial.print("Welcome ");
//       Serial.println(users[i][1]);
//       lcdshow("Welcome brother", users[i][1]);
//       setcolor("green");
//       delay(5000);
//       welcomescreen();
//     
//       break;
//   }
//     i++;
//     if (i == numusers) {
//       Serial.println("User not Detected");
//       lcdshow("User not", "Authorized");
//       delay(1000);
//       setcolor("off");
//       delay(1000);
//       setcolor("blue");
//       delay(1000);
//       setcolor("off");
//       delay(1000);
//       setcolor("blue");
//       delay(1000);
//       setcolor("off");
//       delay(1000);
//       welcomescreen();
//     }
//            
//    }
//    }
